// _gen/asdl/hnode.asdl.h is generated by asdl_main.py

#ifndef HNODE_ASDL
#define HNODE_ASDL

#include <cstdint>

#include "mycpp/runtime.h"
namespace hnode_asdl {

class field;
class hnode_t;

enum class color_e {
  TypeName = 1,
  StringConst = 2,
  OtherConst = 3,
  UserType = 4,
  External = 5,
};
typedef color_e color_t;

namespace hnode_e {
  const int Record = 1;
  const int Array = 2;
  const int Leaf = 3;
  const int External = 4;
};

class hnode_t {
 protected:
  hnode_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  DISALLOW_COPY_AND_ASSIGN(hnode_t)
};

class hnode__Record : public hnode_t {
 public:
  hnode__Record()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(hnode_e::Record),
                      field_mask(), sizeof(hnode__Record)),
        node_type(StrFromC("")),
        fields(NewList<field*>()),
        abbrev(false),
        left(StrFromC("")),
        right(StrFromC("")),
        unnamed_fields(NewList<hnode_t*>()) {
  }

  hnode__Record(Str* node_type, List<field*>* fields, bool abbrev, Str* left,
                Str* right, List<hnode_t*>* unnamed_fields)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(hnode_e::Record),
                      field_mask(), sizeof(hnode__Record)),
        node_type(node_type),
        fields(fields),
        abbrev(abbrev),
        left(left),
        right(right),
        unnamed_fields(unnamed_fields) {
  }

  GC_OBJ(header_);
  Str* node_type;
  List<field*>* fields;
  bool abbrev;
  Str* left;
  Str* right;
  List<hnode_t*>* unnamed_fields;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(hnode__Record, node_type))
         | maskbit(offsetof(hnode__Record, fields))
         | maskbit(offsetof(hnode__Record, left))
         | maskbit(offsetof(hnode__Record, right))
         | maskbit(offsetof(hnode__Record, unnamed_fields));
  }

  DISALLOW_COPY_AND_ASSIGN(hnode__Record)
};

class hnode__Array : public hnode_t {
 public:
  hnode__Array()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(hnode_e::Array),
                      field_mask(), sizeof(hnode__Array)),
        children(NewList<hnode_t*>()) {
  }

  hnode__Array(List<hnode_t*>* children)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(hnode_e::Array),
                      field_mask(), sizeof(hnode__Array)),
        children(children) {
  }

  GC_OBJ(header_);
  List<hnode_t*>* children;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(hnode__Array, children));
  }

  DISALLOW_COPY_AND_ASSIGN(hnode__Array)
};

class hnode__Leaf : public hnode_t {
 public:
  hnode__Leaf()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(hnode_e::Leaf),
                      field_mask(), sizeof(hnode__Leaf)),
        s(StrFromC("")),
        color(color_e::TypeName) {
  }

  hnode__Leaf(Str* s, color_t color)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(hnode_e::Leaf),
                      field_mask(), sizeof(hnode__Leaf)),
        s(s),
        color(color) {
  }

  GC_OBJ(header_);
  Str* s;
  color_t color;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(hnode__Leaf, s));
  }

  DISALLOW_COPY_AND_ASSIGN(hnode__Leaf)
};

class hnode__External : public hnode_t {
 public:
  hnode__External()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(hnode_e::External),
                      field_mask(), sizeof(hnode__External)),
        obj(nullptr) {
  }

  hnode__External(void* obj)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(hnode_e::External),
                      field_mask(), sizeof(hnode__External)),
        obj(obj) {
  }

  GC_OBJ(header_);
  void* obj;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(hnode__External, obj));
  }

  DISALLOW_COPY_AND_ASSIGN(hnode__External)
};

namespace hnode {
  typedef hnode__Record Record;
  typedef hnode__Array Array;
  typedef hnode__Leaf Leaf;
  typedef hnode__External External;
}

class field {
 public:
  field()
      : GC_ASDL_CLASS(header_, 64,
                      field_mask(), sizeof(field)),
        name(StrFromC("")),
        val(nullptr) {
  }

  field(Str* name, hnode_t* val)
      : GC_ASDL_CLASS(header_, 64,
                      field_mask(), sizeof(field)),
        name(name),
        val(val) {
  }

  GC_OBJ(header_);
  Str* name;
  hnode_t* val;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(field, name))
         | maskbit(offsetof(field, val));
  }

  DISALLOW_COPY_AND_ASSIGN(field)
};


}  // namespace hnode_asdl

#endif  // HNODE_ASDL
